Unit SF45R_p;
//    S(x)  C(x) 

interface
uses
SysUtils, Math; { Delphi }
//Lstruct, Lfunc;

function Factorial(n: Word):Extended;
procedure SF45R(X :Real; var C :Real; var S :Real);

implementation

// *****************************************************************************
function Factorial(n: Word):Extended;
var
i:Integer;
f:Extended;
begin
f:=1;
if n<20 then
  begin
    for i:=1 to n do
      f:=f*i;
  end;
if n>=20 then f:=sqrt(2*pi*n)*exp(-n+1/(12*n)*(1-1/(30*n)))*IntPower(n,n);
result:=f;
end;
// *****************************************************************************

procedure SF45R(X :Real; var C :Real; var S :Real);
var
K,L,I :Integer;
Z,H,Y,F,D,E,B,R,T :Real;
A :Array [0..51] of Real;
RK :Array [0..12] of Real;
RL :Array [0..12] of Real;
j,jj:Integer;
sumc,sums,si:Extended;
const
SYS035 :Real = 0.39894228040143267793994605993438;
label
_1,_2,_3,_4,_5,_6,_7;
begin
{   DATA  FORTRAN  }
A[0] := 0.1E-10;
A[1] := -0.366E-9;
A[2] := 0.10898E-7;
A[3] := -0.267681E-6;
A[4] := 0.527608E-5;
A[5] := -0.8105684E-4;
A[6] := 0.9339901E-3;
A[7] := -0.7651297E-2;
A[8] := 0.0411409E0;
A[9] := 0.1271339E0;
A[10] := 0.1743607E0;
A[11] := -0.0808111E0;
A[12] := 0.5479103E0;
A[13] := 0.4E-11;
A[14] := -0.128E-9;
A[15] := 0.4206E-8;
A[16] := -0.11507E-6;
A[17] := 0.2562196E-5;
A[18] := -0.4532192E-4;
A[19] := 0.6174202E-3;
A[20] := 0.6220184E-2;
A[21] := 0.0438681E0;
A[22] := -0.2007174E0;
A[23] := 0.5386666E0;
A[24] := -0.7996168E0;
A[25] := 1.053859E0;
A[26] := 0.1E-11;
A[27] := -0.4E-11;
A[28] := 0.14E-10;
A[29] := -0.54E-10;
A[30] := 0.239E-9;
A[31] := -0.1176E-8;
A[32] := 0.6545E-8;
A[33] := -0.42829E-7;
A[34] := 0.347441E-6;
A[35] := 0.3810219E-5;
A[36] := 0.6627508E-4;
A[37] := -0.2617529E-2;
A[38] := 0.9945488E0;
A[39] := 0.2E-11;
A[40] := -0.6E-11;
A[41] := 0.18E-10;
A[42] := -0.72E-10;
A[43] := 0.298E-9;
A[44] := 0.1346E-8;
A[45] := 0.6798E-8;
A[46] := -0.39518E-7;
A[47] := 0.275996E-6;
A[48] := -0.2475448E-5;
A[49] := 0.3202967E-4;
A[50] := -0.7552029E-3;
A[51] := 0.0608819E0;
Z := Abs(X);
//if Z=8.0 then begin C:=0.6393; S:=0.5120; goto _7; end;
if ( Z-8.0 ) <= 0
 then goto _1
 else if ( Z-8.0 ) > 0
       then goto _2
       else goto _2;
_1:
  sumc:=0;
  sums:=0;
  jj:=12;
  for j:=0 to jj do
  begin
    si:=power(-1,j)*power(x,2*j)/((4*j+1)*Factorial(2*j));
    sumc:=sumc+si;
    si:=power(-1,j)*power(x,2*j+1)/((4*j+3)*Factorial(2*j+1));
    sums:=sums+si;
  end;
  c:=sqrt(2*x/pi)*sumc;
  s:=sqrt(2*x/pi)*sums;
//H := Z/8.0;
//K := 0;
goto _7;
_2:
H := 8.0/Z;
K := 26;
_3:
L := K+13;
Y := 4.0*H*H-2.0;
RK[0] := A[1+K-1];
RK[1] := Y*RK[0]+A[2+K-1];
RL[0] := A[1+L-1];
RL[1] := Y*RL[0]+A[2+L-1];
for I:=3 to 13 do
 begin
  RK[I-1] := Y*RK[I-2]-RK[I-3]+A[I+K-1];
  RL[I-1] := Y*RL[I-2]-RL[I-3]+A[I+L-1];
 end;
_4:
F := SYS035;
D := F*RK[12];
E := F*RL[12]*H;
B := Sqrt(Z);
if ( Z-8.0 ) < 0
 then goto _5
 else if ( Z-8.0 ) > 0
       then goto _6
       else goto _6;
_5:
C := D*B;
S := E*B;
goto _7;
_6:
R := Sin(Z);
T := Cos(Z);
C := 0.5+(D*R-E*T)/B;
S := 0.5-(E*R+D*T)/B;
_7:
end;

end.
